//+------------------------------------------------------------------+
//|                                                       K3M_M1.mq4 |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 30
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

//---- input parameters
extern int K3M1=9;
//---- buffers
double RSIBuffer[];
double PosBuffer[];
double NegBuffer[];
double Uptrend[];
double Downtrend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(5);
   //---- indicator line
   SetIndexStyle(0, DRAW_HISTOGRAM, EMPTY,4);
   SetIndexBuffer(0, Uptrend);
   SetIndexStyle(1, DRAW_HISTOGRAM, EMPTY,3);
   SetIndexBuffer(1, Downtrend);
   SetIndexBuffer(2,RSIBuffer);
   SetIndexBuffer(3,PosBuffer);
   SetIndexBuffer(4,NegBuffer);

//---- name for DataWindow and indicator subwindow label
//   short_name="K3M_M1("+K3M1+")";
//   IndicatorShortName(short_name);
//   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,K3M1);
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Relative Strength Index                                          |
//+------------------------------------------------------------------+
int start()
  {
   int    i,counted_bars=IndicatorCounted();
   double rel,negative,positive;
//----
   if(Bars<=K3M1) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=K3M1;i++) RSIBuffer[Bars-i]=0.0;
//----
   i=Bars-K3M1-1;
   if(counted_bars>=K3M1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      double sumn=0.0,sump=0.0;
      if(i==Bars-K3M1-1)
        {
         int k=Bars-2;
         //---- initial accumulation
         while(k>=i)
           {
            rel=Close[k]-Close[k+1];
            if(rel>0) sump+=rel;
            else      sumn-=rel;
            k--;
           }
         positive=sump/K3M1;
         negative=sumn/K3M1;
        }
      else
        {
         //---- smoothed moving average
         rel=Close[i]-Close[i+1];
         if(rel>0) sump=rel;
         else      sumn=-rel;
         positive=(PosBuffer[i+1]*(K3M1-1)+sump)/K3M1;
         negative=(NegBuffer[i+1]*(K3M1-1)+sumn)/K3M1;
        }
      PosBuffer[i]=positive;
      NegBuffer[i]=negative;
      if(negative==0.0) RSIBuffer[i]=0.0;
      else RSIBuffer[i]=100.0-100.0/(1+positive/negative);
       if (RSIBuffer[i]>50) Uptrend[i]=30;
       else Uptrend[i]=0;
       if (RSIBuffer[i]<50) Downtrend[i]=20;
       else Downtrend[i]=0;
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+